/*  Simulating Bullet cluster.
*/

#if INIT_TYPE == INIT_BULLET_CLUSTER 

  #define BULLET_STET           0
  #define BULLET_NEWTON         1
  #define IsValidCellBullet(x, y, z)       ((x<0 || y<0 || z<0) ? 0 : GridDisk[x][y][z]) 
  #define IsValidBigCellBullet(x, y, z)    ((x<0 || y<0 || z<0) ? 0 : Grid3Disk[x][y][z])
  #define InsideStetDiskBullet(ax, ay, az) (StetDisk[ax][ay][az])
  #define BULLET_ZOOM          2
  #define BULLET_CENTERX       (NBCELLX_GRID/2)
  #define BULLET_OFFSETX       (BULLET_CENTERX/BULLET_ZOOM)
  #define BULLET_CENTERY       (NBCELLY_GRID/2)
  #define BULLET_OFFSETY       (BULLET_CENTERY/BULLET_ZOOM)
  #define BULLET_LG            (1.87 * MEGAPARSEC)
  #define BULLET_LG_GRID       (BULLET_LG * BULLET_ZOOM)
//  #define BULLET_GAMMA         0.3333333  // Spherical type best ?
//  #define BULLET_GAMMA         0.5  // Spherical type best ?
//  #define BULLET_GAMMA         0.8  // Spherical type best ?
//  #define BULLET_GAMMA         0.1  // Spherical type best ?
//  #define BULLET_GAMMA         0.0  // Spherical type best ?
//  #define BULLET_GAMMA         0.1  // Spherical type best ?
//  #define BULLET_GAMMA         0.01  // Spherical type best ?
//  #define BULLET_GAMMA         0.001  // Spherical type best ?
//  #define BULLET_GAMMA         0.005  // Spherical type best ?
//  #define BULLET_GAMMA         0.005  // Spherical type best ?
//  #define BULLET_GAMMA         0.05  // ...
//  #define BULLET_GAMMA         0.025  // Best fitted between the "hole" and the square in place of the circles.
//  #define BULLET_GAMMA         0.05  // 
//  #define BULLET_GAMMA         0.08  // pas mal 
//  #define BULLET_GAMMA         0.12  // 
//  #define BULLET_GAMMA         0.24  // 
//  #define BULLET_GAMMA         0.5  // 
  #define BULLET_GAMMA         0.8  // 
  #define BULLET_INCR          0  // For applying a mean value over the final results.
  #define BULLET_WLRHO_RESCALE     1.E27     // For setting up values.
      //  #define BULLET_NBPART_CELL      1.E9      // NE MARCHE PAS !!!!!
  #define BULLET_NBPART_CELL      1.E8      //idem que 1.E9 : OK OK pour Newton Deprecated.
  #define BULLET_SIGRATIO         2
  #define BULLET_IR_MAX           3000                   // fitted
  #define BULLET_PART_DIST			  (BULLET_R_CLUSTER / BULLET_IR_MAX)
  #define BULLET_DR_MIN           (0.01 * BULLET_PART_DIST)         // dr is minimised.                 
  #define BULLET_PART_MASS        (5.8E11 * MASS_SUN)     // TO BE FITTED                 
  #define BULLET_CENTER1_X        0                                         // Gas bunch
  #define BULLET_CENTER1_Y        0                       
  #define BULLET_CENTER2_X        (0.375 * MEGAPARSEC)     // First cluster of gal            
  #define BULLET_CENTER2_Y        0                 
  #define BULLET_CENTER3_X        (-0.375 * MEGAPARSEC)     // 2nd cluster of gal            
  #define BULLET_CENTER3_Y        0                 
  #define BULLET_CENTER5_X        0            
  #define BULLET_CENTER5_Y        0                 
//  #define BULLET_SIGMA1           (100.0 * MEGAPARSEC)  //        
//  #define BULLET_SIGMA1           (150.0 * MEGAPARSEC)  //        
//  #define BULLET_SIGMA1           (200.0 * MEGAPARSEC)  //        
//  #define BULLET_SIGMA1           (50.0 * MEGAPARSEC)  //        
//  #define BULLET_SIGMA1           (125.0 * MEGAPARSEC)  //        

  #define BULLET_SIGMA1           (0.5625 * MEGAPARSEC)  // good fit.        
  #define BULLET_SIGMA2           (0.13125 * MEGAPARSEC)    //             
  #define BULLET_SIGMA3           (0.13125 * MEGAPARSEC)
  #define BULLET_SIGMA5           0
/*
  // TEST :  tentative de faire aparaitre la petite bulle a gauche et a droite....
  #define BULLET_SIGMA1           (0.5625 * MEGAPARSEC/2)  // good fit.        
  #define BULLET_SIGMA2           (0.13125 * MEGAPARSEC/2)    //             
  #define BULLET_SIGMA3           (0.13125 * MEGAPARSEC/2)
  #define BULLET_SIGMA5           0
*/

//  #define BULLET_RHOMAX1          (0.1*(6.E-3)*0.01)              //  
//  #define BULLET_RHOMAX1          (0.2*(6.E-3)*0.01)              //  
//  #define BULLET_RHOMAX1          (0.05*(6.E-3)*0.01)              //  
//  #define BULLET_RHOMAX1          (0.1*(6.E-3)*0.01)              //  
//  #define BULLET_RHOMAX1          (0.15*(6.E-3)*0.01)              //   
//  #define BULLET_RHOMAX1          (0.12*(6.E-3)*0.01)              //  
//  #define BULLET_RHOMAX1          (0.13*(6.E-3)*0.01)              // good fit.  
//  #define BULLET_RHOMAX1          (0.07*(6.E-3)*0.01)              // refit after rescale  
//  #define BULLET_RHOMAX1          (0.01*(6.E-3)*0.01)              // 
//  #define BULLET_RHOMAX1          (0.04*(6.E-3)*0.01)              // 
//  #define BULLET_RHOMAX1          (0.025*(6.E-3)*0.01)              // 
//  #define BULLET_RHOMAX1          (0.014*(6.E-3)*0.01)              // 
//  #define BULLET_RHOMAX1          (0.02*(6.E-3)*0.01)              // with 256 cells 
//  #define BULLET_RHOMAX1          (0.005*(6.E-3)*0.01)              // with 2048 cells 

//  #define BULLET_RHOMAX1          (0.02*(6.E-3)*0.01)              // with 256 cells  
//  #define BULLET_RHOMAX1          (0.0182*(6.E-3)*0.01)              // 
//  #define BULLET_RHOMAX1          (0.09*(6.E-3)*0.01)              
  #define BULLET_RHOMAX1          (0.03*(6.E-3)*0.01)              // with 256 cells THE BEST better.
//  #define BULLET_RHOMAX1          (0.002*(6.E-3)*0.01)              // with 1024 cells  // Pas assez... pas loin 
//  #define BULLET_RHOMAX1          (0.003*(6.E-3)*0.01)              // with 1024 cells  // un peu trop 
//  #define BULLET_RHOMAX1          (0.0025*(6.E-3)*0.01)               // with 1024 cells encore un peu trop
//  #define BULLET_RHOMAX1          (0.0022*(6.E-3)*0.01)               // with 1024 cells 
//  #define BULLET_RHOMAX1          (0.0025*(6.E-3)*0.01)               //  un peu mieux
//  #define BULLET_RHOMAX1          (0.00235*(6.E-3)*0.01)               //  
//  #define BULLET_RHOMAX1          (0.0021*(6.E-3)*0.01)               //  
  #define BULLET_RHOMAX2          (0.1*(6.E-3)*0.01)              //  
  #define BULLET_RHOMAX3          (0.1*(6.E-3)*0.01)              // 
  #define BULLET_RHOMAX4          0              // 
  #define BULLET_RHOMAX5          0              // PAS MAL 
  #define BULLET_STET_R_MAX       (15 * KILPARSEC)  // 
  #define BULLET_LGMAX_FILENAME   100
  #define BULLET_INITIALMASS_GNUFILE_NAME_WITHOUTEXT       "gnuBulletIn"
  #define BULLET_POTENTIAL_GNUFILE_NAME_WITHOUTEXT         "gnuBulletPot"
  #define BULLET_WLMASS_GNUFILE_NAME_WITHOUTEXT            "gnuBulletWl"
  #define BULLET_POTENTIAL_GNUFILE_NAME_WITHOUTEXT_NEWTON  "gnuBulletPotNewt"
  #define BULLET_WLMASS_GNUFILE_NAME_WITHOUTEXT_NEWTON     "gnuBulletWlNewt"
  #define BULLET_GNUFILE_NAME_EXT                          ".txt"
  #define BULLET_GNUEXEC_FILE_NAME                         "PlotGnuBullet.gnu" 

/* ---- Used by potential.c ----- */
  extern double CellNbPart[NBCELLX_GRID+2][NBCELLY_GRID+2][NBCELLZ_GRID];
  extern double CellNbPartStetGas[NBCELLX_GRID+2][NBCELLY_GRID+2][NBCELLZ_GRID];
           // +2 for allowing the test of x, y, z out of bounds of regular grid.

  extern void BulletCalc();
  extern void InitStetBullet();
  extern double GetStetCorrBullet(double NbPartInStet, unsigned int ix, unsigned int iy, unsigned int iz);
  extern void TestBullet();

#endif