extern void InitFFT();
extern void GravitPotentialCalculateByFFT();

#if MODE_CALCUL_POTENTIAL==MODE_FFT

typedef struct                                                         // Redefining complex numbers...
{
    double re, im;
} double_complex;
__inline double_complex mul_complex(double_complex a, double_complex b)
{
  double_complex z = {a.re * b.re - (a.im * b.im), a.re * b.im + a.im * b.re};
  return z;
}
__inline double_complex mul_real_complex(double_complex a, double_complex b)
{
  double_complex z = {a.re * b.re, a.re * b.im};
  return z;
}
__inline double_complex add_complex(double_complex a, double_complex b)
{
  double_complex z = {a.re + b.re, a.im + b.im};
  return z;
}
__inline double_complex expi_complex(double a)
{
  double_complex z = {cos(a), sin(a)};
  return z;
}
__inline double_complex sub_complex(double_complex a, double_complex b)
{
  double_complex z = {a.re - b.re, a.im - b.im};
  return z;
}
#define FFT_PLANNING_OPTION   FFTW_ESTIMATE   // FFTW_ESTIMATE seams to be enough for a power of 2.
  
#else
#endif

