/************************************************* GENERAL *************************************************/
#define PRINT_ECHO                  1                    // For console print echoes.

/* ------------------------------- Plotting unit ------------------------------------- */
#if (NB_DIM == 2)
  #if MODE_DEBUG == DEBUG_SOLSYST
    #define PLOT_DIST_UNIT              EARTH_SUN_DIST
  #else
    #define PLOT_DIST_UNIT              KILPARSEC
  #endif
#elif (NB_DIM == 3)
    #define PLOT_DIST_UNIT              EARTH_SUN_DIST
#endif

/* ------------------------------- Directory for files -------------------------------- */
#if MODE_DEBUG == DEBUG_SOLSYST || MODE_DEBUG == DEBUG_NORM
  #define ROOT_NAME                 "i:\\Debug\\"        // Beginning the path name of the files.
#else
  #define ROOT_NAME                 "i:\\"               // Beginning the path name of the files.
#endif

/****************************************** Discarding particles mechanism *******************************/
#define DISCARD_DIST	  (8 * R_GALAXY)             // Above this dist from (0,0) the part is calc but not ploted.
#define RMAX_PLOT       (1.1*R_GALAXY)
#define XMAX_PLOT       (1.1*R_GALAXY)
#define YMAX_PLOT       (1.1*R_GALAXY)
extern int NbPartDisc;              // Nb of discarded particles because too far from the group.

/****************************************** SciLab line colors *******************************************/
#define NBCOLOR			    7
extern unsigned char    Color[NBCOLOR];

/***************************************** MACROS and FUNCTIONS *****************************************/
extern void InitHmi();
extern void PlotPartsOneStep(unsigned long int ind);
extern void PlotOpenCloseFileIfNeeded(unsigned long int StepNum);
extern void PlotEndFile();
extern long int GetTotalTime();
extern void PlotInitDiscardedBeforeLoop();
extern void PlotDetectDiscarded(int ParticleNum);
extern void PrintSimulInfoInFile(FILE *pFile, int File);
extern void PlotDebugOpen();
extern void PlotDebug(int i);
extern void PlotDebugClose();
