/* --------------------------------------- PERIODIC MODE ------------------------------------------------- */
#if NB_DIM == 2
  #define PERIODIC_CALCUL  0            // The galaxy or object is NOT repeated periodically.
#elif NB_DIM == 3
  #define PERIODIC_CALCUL  1            // The galaxy or object is repeated periodically
#else
#endif
  
#if PERIODIC_CALCUL == 0    // Coded with macros: avoid any call with pop push, for perfs.
  #define GetModuloPeriodic(x, period)    (x)
  #define GridDistance(x)                 abs(x)  
#elif PERIODIC_CALCUL == 1 
  #define GridDistance(x)  ((abs(x) < NBCELLX_GRID/2) ? abs(x) : NBCELLX_GRID - abs(x))
  extern unsigned int GetModuloPeriodic(int x, unsigned int period);
  extern double GetDoubleModuloPeriodic(double x);
  extern unsigned char GetCellPeriod(double pos[], unsigned int NumCell[]);
#endif 
