/* ------------------------------ STET mode -------------------------------- */
#define STET_SIMPLE       0 
#define STET_COMPLEX      1 
#define STET_BULLET       2 
#define STET_MODE         STET_BULLET                        // TOUCH THIS ONE.

/* ------------------------------ STET model -------------------------------- */
#if GRAVIT_MODEL == STET
  #if (NB_DIM == 3)
                      //    #define STET_R_MAX                  (LG_GRID/4.) 
    #define STET_R_MAX                  (LG_GRID/16.) 
  #else                                                         // NB_DIM = 2
    #if MODE_DEBUG == DEBUG_SOLSYST          
      #if STET_MODE == STET_SIMPLE
        #define STET_R_MAX              (10 * EARTH_SUN_DIST)
      #elif STET_MODE == STET_COMPLEX
        #define STET_R_MAX              (21 * KILPARSEC)
      #elif STET_MODE == STET_BULLET
        #define STET_R_MAX              BULLET_STET_R_MAX
      #endif
    #else       // NORMAL case   
      #if STET_MODE == STET_SIMPLE
        //#define STET_R_MAX              (2 * KILPARSEC)   // 2 : Small galaxies.
        #define STET_R_MAX              (21 * KILPARSEC)   // 2 : Small galaxies.
      #elif STET_MODE == STET_COMPLEX
        #define STET_R_MAX              (21 * KILPARSEC)
      #elif STET_MODE == STET_BULLET
        #define STET_R_MAX              BULLET_STET_R_MAX
      #endif
    #endif          
  #endif

  /* ---------------------------- For calculation of StetNbPartInit --------------------------- */
  #define STET_DISK_SURF              (PI * R0_GAL_AROUND_SUN * R0_GAL_AROUND_SUN) // TEST1 PROVISOIRE
                                                          // = (17/8) sqrt(5.8/0.84) = 2 sqrt(7) = 5.5 
        //    #define STET_DISK_SURF              (PI * R0_GAL_AROUND_SUN * R0_GAL_AROUND_SUN)
        //    #define STET_DISK_SURF              (PI * STET_R_MAX * STET_R_MAX)    // ICICICIC PROVISOIRE !!!!!!!!!!!!!!!!!!!!!  RecupsimuOK
  #define FINAL_GAL_RAY               R_GALAXY          //  
        //    #define FINAL_GAL_RAY               (12 * R_DISK_HOHL)   // Approx 90% of gal mass in this disk. (a fact)
        //    #define FINAL_GAL_RAY               (2 * R_DISK_HOHL)   // JUST A TRY ! dilution...
        //    #define FINAL_GAL_RAY               (12 * DIAM_DISK_HOHL) // =(LG_GRID/2)  ICICICIC PROVISOIRE !!!!!!!!!!!!!!!!!!!!!  RecupsimuOK
        //    #define FINAL_GAL_RAY               (R_DISK_HOHL) // TEST1 PROVISOIRE
        //    #define FINAL_GAL_RAY               (6*R_DISK_HOHL) // TEST1 PROVISOIRE
        //    #define FINAL_GAL_RAY               (0.1*R_DISK_HOHL) // TEST1 PROVISOIRE
        //    #define FINAL_GAL_RAY               (0.1*R_DISK_HOHL) // * sqrt( (17/8) 5.8E11 * MASS_SUN / (100000 * 0.84E6 * MASS_SUN) 
  #define FINAL_GAL_SURF              (PI * R_GALAXY * R_GALAXY)      //

  /* ---------------------------- For calculation of extinction mechanism --------------------- */
  #define R0_GAL_AROUND_SUN           (LN_2 / (SIGMA_EXT * NO_GAL_AROUND_SUN))    // in m.
  #define RATIO_N_RHO                 (NO_GAL_AROUND_SUN / RHO_GAL_AROUND_SUN)    // roughtly E26             
             //    #define NGAS_MAX                       (3 * NO_GAL_AROUND_SUN)   // First simul             
    //#define NGAS_MAX                    (5 * NO_GAL_AROUND_SUN)             
    //#define NGAS_MAX                    (1.5 * NO_GAL_AROUND_SUN)             
    //#define NGAS_MAX                    (15 * NO_GAL_AROUND_SUN)             
    //#define NGAS_MAX                    (150 * NO_GAL_AROUND_SUN)             
    //#define NGAS_MAX                    (80 * NO_GAL_AROUND_SUN)  // resultat avec gamma=2, et alpha=1/2: dilution             
    //#define NGAS_MAX                    (120 * NO_GAL_AROUND_SUN)           // dilution  
    //  #define NGAS_MAX                    (150 * NO_GAL_AROUND_SUN)         // dilution    
  #define NGAS_MAX                    (3 * NO_GAL_AROUND_SUN)                 // simu 3 simu 4     
//  #define NGAS_MAX                    (0.0000000000001 * NO_GAL_AROUND_SUN) // simu 7    

  #if STET_MODE == STET_COMPLEX || STET_MODE == STET_BULLET 

    /* ---------------------------- For a complicated N = N(rho), using exp function (better) -- */
//    #define NGAS_ALPHA                  0.5    // Not enough with gamma = 2. 
//    #define NGAS_ALPHA                  0.9 
    #define NGAS_ALPHA                  0.5 
//    #define NGAS_GAMMA                  2. 
    #define NGAS_GAMMA                  2. 
    #define NGAS_K                      (NGAS_ALPHA * log(NGAS_GAMMA) / RHO_GAL_AROUND_SUN) 
                     // NO_GAL_AROUND_SUN = roughtly GetNGas(RHO_GAL_AROUND_SUN)

    /* ---------------------------- For a complicated N = N(rho), using tan function (deprecated) */
    #define RATIO_LIMIT                 0.01
    #define RHO_LIMIT                   (RATIO_LIMIT * RHO_GAL_AROUND_SUN)
    #define RATIO_LOWDELTA              0.0000001  // OK : 1567/1500    
    #define RHO_LOWDELTA                (RATIO_LOWDELTA * RHO_LIMIT)

    /* ---------------------------- For calculation of N = N(rho), brutal exponential ---------- */
//    #define RHO_A       (0.9 * RHO_GAL_AROUND_SUN)
//    #define RHO_A       (0.1 * RHO_GAL_AROUND_SUN)        // simu 3
//    #define RHO_A       (2.0 * RHO_GAL_AROUND_SUN)          // simu 4
//    #define RHO_A       (0.1 * RHO_GAL_AROUND_SUN)          // simu 1 et 7 
//    #define RHO_A       (0.1 * RHO_GAL_AROUND_SUN)          // simu 8
//    #define RHO_A       (0.02 * RHO_GAL_AROUND_SUN)          // simu 13
    #define RHO_A       (0.0002 * RHO_GAL_AROUND_SUN)          // simu 13
//    #define RHO_B       (1.1 * RHO_GAL_AROUND_SUN)
//    #define RHO_B       (1.01 * RHO_GAL_AROUND_SUN)
//    #define RHO_B       (1.0001 * RHO_GAL_AROUND_SUN)
//    #define RHO_B       (1.05 * RHO_GAL_AROUND_SUN)
//    #define RHO_B       (1.1 * RHO_GAL_AROUND_SUN)
//    #define RHO_B       (0.2 * RHO_GAL_AROUND_SUN)        // simu 3
//    #define RHO_B       (2.5 * RHO_GAL_AROUND_SUN)        // simu 4
//    #define RHO_B       (0.2 * RHO_GAL_AROUND_SUN)        // simu 1 et 7
//    #define RHO_B       (1.0 * RHO_GAL_AROUND_SUN)        // simu 8
//    #define RHO_B       (0.07 * RHO_GAL_AROUND_SUN)        // simu 13
//    #define RHO_B       (0.0007 * RHO_GAL_AROUND_SUN)        // simu 13
    #define RHO_B       (10. * RHO_GAL_AROUND_SUN)        // simu 13
    #define DIFF_RHOAB  (RHO_B - RHO_A)                   // 
    #define SIGMA2R0    (DIFF_RHOAB * DIFF_RHOAB)

    /* ---------------------------- For calculation of StetAddedContrib ------------------------ */
    #define STET_ADDED_CONTRIB_RATIO_OVERIGM      0.3333333333 // 1/3, calculated. To be simulated.
    #define STET_ADDED_CONTRIB_RATIO_OVERSOLSYST  0.0526315789473684210526315    // 1/19
    #define STET_IGM_CONTRIB_RATIO_OVERSOLSYST    0.1578947368421052631578947    // 3/19
                                                            // Difficult to estimate precisely.
    /* ---------------------------- Miscellaneous ----------------------------------------------- */
    #define LGMAX_STETR                 (NBCELLX_GRID * NBCELLY_GRID * NBCELLZ_GRID)
  #endif

//////////// OLD VERSION
//  #define STET_ADDED_NBPART           1    // If no stars are there in the disk, there is gas or remaining ...
//  #define STET_ADDED_NBPART           50000    // not enugh. Still exploding.
//  #define STET_ADDED_NBPART           1000000    // Very good. Much better than NEWTON.
//  #define STET_ADDED_NBPART           500000    // Very good, may be better. Center is moving after 80 round.
//  #define STET_ADDED_NBPART           250000    // Quite the same as 500 000
//  #define STET_ADDED_NBPART           50000    // Grumeaux, explose vite puis collapse puis se stabilise apparemment sans se disperser. Plus de bras ou alors si mais vers la fin et tres grands et flous. Reste 4 gros grumeaux a la fin. Au debut contient des vitesses tangentielles negatives autour de certains grumeaux. Les 4 gros grumeaux restent juqu'a medium100.
//  #define STET_ADDED_NBPART             5000    // petits grumeaux qui explosent. Difficile de fitter pour enlever l'explosion. Tres bonne demonstration des apparitions rapides des voids. 
//  #define STET_ADDED_NBPART           50000    // Avec NbPartInit mean geometric. Amplified accel. Bad result (idem HOHL at the end).)
//  #define STET_ADDED_NBPART           25000    // Grumeaux plus petits que 50000. Forme un anneau en regime permanent.
//  #define STET_ADDED_NBPART           5000    // Grumeaux encore plus petits. StetCorr = environ entre 10 et 0,5. Se stabilise encore plus nettement en anneaux. Obtient des filaments en transitoires tres visibles. 
//  #define STET_ADDED_NBPART           100    // 952 - 0,94. Voids "exageres" puis grumeaux a anneaux, puis galaxie  anneau et grosse dispersion autour. 
//  #define STET_ADDED_NBPART             10    // 5000-5 no more ring. Quite constant matter density.
//  #define STET_ADDED_NBPART             1    // quite the same as 10 
//  #define STET_ADDED_NBPART             50000    // 

//////////// NEW VERSION
//  #define STET_ADDED_NBPART             50000      
//  #define STET_ADDED_NBPART             1000      
//  #define STET_ADDED_NBPART             1      
  #if STET_MODE == STET_COMPLEX 
  #elif STET_MODE == STET_SIMPLE 
     //    #define STET_ADDED_NBPART             45000   // Valid if NbPart = 100 000    
         #define STET_ADDED_NBPART             (100*45000)     // Now with NbPart = 10 000 000
  #else
  #endif

  /************************************** GLOBAL VARIABLES ********************************************/
  extern unsigned int StetNbPartInit;              // Nb of particles in a STET disk at init time.
  extern unsigned char StetDisk[NBCELLX_GRID][NBCELLY_GRID][NBCELLZ_GRID];
  extern double StetCorrMax, StetCorrMin;
    //extern unsigned int NbPartInStetDebug[NBCELLX_STETDISK][NBCELLY_STETDISK][NBCELLZ_STETDISK];
  extern double StetAddedContrib;
  extern double StetSolSystContrib;
  #if STET_MODE == STET_COMPLEX || STET_MODE == STET_BULLET
    extern double StetR[NBCELLX_GRID][NBCELLY_GRID][NBCELLZ_GRID];
    extern double StetCorrMemo[NBCELLX_GRID][NBCELLY_GRID][NBCELLZ_GRID];
  #endif
  #if STET_MODE == STET_COMPLEX
    extern unsigned int StetNbPart[NBCELLX_GRID][NBCELLY_GRID][NBCELLZ_GRID];
  #endif

  /************************************** MACROS and FUNCTIONS *****************************************/
  #if STET_MODE == STET_SIMPLE 
    #define InsideStetDisk(ix, iy, iz, ax, ay, az)    (StetDisk[ax][ay][az])
  #elif STET_MODE == STET_COMPLEX
    extern unsigned char InsideStetDisk(unsigned int ix, unsigned int iy, unsigned int iz, 
                             unsigned int ax, unsigned int ay, unsigned int az);
  #else    // Nothing there. Bullet: see bulletcluster.c. Here its only for generation.
    #define InsideStetDisk(ix, iy, iz, ax, ay, az)    (StetDisk[ax][ay][az])
  #endif 

#endif   // End of <<#if GRAVIT_MODEL == STET>> 

  /******************************** MACROS and FUNCTIONS (following) **********************************/
  extern void InitStet();
  extern void ReInitStet();
  extern void GetAccelFromGalaxyStet(int PartInd, double accel[], unsigned int NumCell[]);
  extern void PrintStetInfo(FILE *pFile);
  extern double GetStetCorr(unsigned int NbPartInStet, unsigned int ix, unsigned int iy, unsigned int iz);
  extern void TestStet();

